VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "LunaCal 1.0"
   ClientHeight    =   3945
   ClientLeft      =   135
   ClientTop       =   420
   ClientWidth     =   7635
   Icon            =   "Date.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3945
   ScaleWidth      =   7635
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2280
      Top             =   2880
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   255
      Left            =   3000
      TabIndex        =   20
      Top             =   3600
      Width           =   735
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print"
      Height          =   255
      Left            =   2160
      TabIndex        =   19
      Top             =   3600
      Width           =   735
   End
   Begin VB.Frame fraOutput 
      Caption         =   "Output"
      Height          =   3855
      Left            =   3960
      TabIndex        =   11
      Top             =   0
      Width           =   3615
      Begin VB.ComboBox cboOption2 
         Height          =   315
         Left            =   1080
         TabIndex        =   17
         Top             =   1080
         Width           =   2175
      End
      Begin VB.ComboBox cboOption 
         Height          =   315
         Left            =   1080
         TabIndex        =   15
         Top             =   720
         Width           =   2175
      End
      Begin VB.OptionButton optBody 
         Caption         =   "Moon, Sun, Planets"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   480
         Width           =   2175
      End
      Begin VB.OptionButton optConvert 
         Caption         =   "Convert Date"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   240
         Value           =   -1  'True
         Width           =   1455
      End
      Begin VB.Label lblOutput3 
         BackColor       =   &H8000000E&
         Height          =   2175
         Left            =   120
         TabIndex        =   18
         Top             =   1560
         Width           =   3375
      End
      Begin VB.Label lblOption2 
         Caption         =   "Option2"
         Height          =   255
         Left            =   120
         TabIndex        =   16
         Top             =   1080
         Width           =   975
      End
      Begin VB.Label lblOption 
         Caption         =   "Option"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   720
         Width           =   975
      End
   End
   Begin VB.Frame fraInput 
      Caption         =   "Input"
      Height          =   2535
      Left            =   0
      TabIndex        =   2
      Top             =   120
      Width           =   3855
      Begin VB.CommandButton cmdChangeWeather 
         Caption         =   "Change"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   1920
         Width           =   735
      End
      Begin VB.CommandButton cmdChangeLocation 
         Caption         =   "Change"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   960
         Width           =   735
      End
      Begin VB.CommandButton cmdChangeDate 
         Caption         =   "Change"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   600
         Width           =   735
      End
      Begin VB.CommandButton cmdChangeTime 
         Caption         =   "Change"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   735
      End
      Begin VB.Label lblWeather 
         Caption         =   "Weather"
         Height          =   495
         Left            =   960
         TabIndex        =   10
         Top             =   1920
         Width           =   2775
      End
      Begin VB.Label lblLocation 
         Caption         =   "Location"
         Height          =   975
         Left            =   960
         TabIndex        =   8
         Top             =   960
         Width           =   2775
      End
      Begin VB.Label lblDate 
         Caption         =   "Date"
         Height          =   495
         Left            =   960
         TabIndex        =   6
         Top             =   600
         Width           =   2775
      End
      Begin VB.Label lblTime 
         Caption         =   "Time"
         Height          =   375
         Left            =   960
         TabIndex        =   4
         Top             =   240
         Width           =   2775
      End
   End
   Begin VB.CommandButton cmdCRight 
      Caption         =   "(C) Roy Hoffman 2000"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   3600
      Width           =   1935
   End
   Begin VB.CommandButton cmdT 
      Caption         =   "Test"
      Height          =   255
      Left            =   3240
      TabIndex        =   0
      Top             =   2880
      Width           =   615
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Main control panel for program
'Inputs on the left and outputs on the right
Dim blnAllowChange As Boolean 'Used to disable updates during programmed modifications
Sub Evaluate()
'Evaluate the inputs and outputs and display them
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    
    'Date
    dblDate = frmDate.EvaluateDate(udtDate) 'Determine radix date at 0:00 UTC
    lblDate = "Date: " & frmDate.WriteDate(udtDate)
    'Location
    Call frmLocation.EvaluateLoc
    lblLocation = frmLocation.WriteLocation
    'Time
    If udtDate.enmDateType >= Gregorian Then
        Call frmTime.EvaluateTime(blnValid) 'Determine time relative to radix date
        lblTime = "Time: " & frmTime.WriteTime(udtTime)
        If Not frmTime.Visible Then Unload frmTime
    Else
        blnValid = True
        lblTime = "Time: not applicable"
        dblTime = 0
    End If
    'Weather
    Call frmWeather.GetWeatherNow(dblDate, dblTime, udtWeatherNow)
    lblWeather = "Weather " & frmWeather.WriteWeather
    'Output
    If blnValid Then
        If optConvert Then
            Call ToDateTime(dblDate + dblTime, udtDateOut, cboOption.ListIndex, udtTimeOut, cboOption2.ListIndex, blnValid)
            If blnValid Then
                lblOutput3 = frmDate.WriteDate(udtDateOut)
                If udtDateOut.enmDateType >= Gregorian Then lblOutput3 = lblOutput3 & " " & frmTime.WriteTime(udtTimeOut)
                If Not frmTime.Visible Then Unload frmTime
            Else
                lblOutput3 = "Date out of range."
            End If
        Else
            Select Case cboOption.ListIndex
                Case 0: 'Sun
                    Call Sun
                Case 1:
                    Call Moon
                Case 2, 3, 4:
                    Call Planet
                Case Else:
                    lblOutput3 = "Invalid action selected"
            End Select
        End If
    Else
        lblOutput3 = "Invalid time for this situation."
    End If
End Sub
Friend Function ZeroTime(dblFixed As Double, enmTimeType As TimeType) As Double
'Find the start and end of the current day and how many days to adjust from the UTC day
    Dim cUTC As New clsUTC
    Dim cLocal As New clsLocalTime
    Dim cMeanSolar As New clsMeanSolar
    Dim cTrueSolar As New clsTrueSolar
    Dim cGMST As New clsGMST
    Dim cLST As New clsLST
    Dim cSeasonal As New clsSeasonal
    Dim cMoon As New clsMoon
    Dim udtTimeOut As Mytime
        
    Select Case enmTimeType
        Case 0: 'UTC
            ZeroTime = cUTC.ZeroTime(dblFixed)
        Case 1: 'Local time
            ZeroTime = cLocal.ZeroTime(dblFixed)
        Case 2: 'Mean solar
            ZeroTime = cMeanSolar.ZeroTime(dblFixed)
        Case 3: 'True solar
            ZeroTime = cTrueSolar.ZeroTime(dblFixed)
        Case 4: 'GMST
            Call cUTC.ZeroTime(dblFixed)
        Case 5: 'LST
            Call cUTC.ZeroTime(dblFixed)
        Case 6: 'Seasonal
            ZeroTime = cTrueSolar.ZeroTime(dblFixed)
    End Select
End Function
Friend Sub ToDateTime(dblFixed As Double, udtDateIn As MyDate, enmDateType As DateType, udtTimeIn As Mytime, enmTimeType As TimeType, blnValid As Boolean)
'Convert fixed radix to date and time
    Dim cJD As New clsJD
    Dim cJDE As New clsJDE
    Dim cMJD As New clsMJD
    Dim dblStart As Double 'Start of day
    Dim dblEnd As Double 'End of day
    Dim intDaysToAdd As Integer 'Correction in days because of the time
    Dim dblZeroTime As Double
    Dim intDayShift As Integer
    
    
    udtDateIn.enmDateType = enmDateType
    If enmDateType < Gregorian Then
    'radix types do not have a time type component
    'so only the day number needs to be calculated
        Select Case enmDateType
            Case Fixed: 'Fixed radix
                udtDateIn.dblDayNumber = dblFixed
            Case JD: 'Julian day number according to UTC
                udtDateIn.dblDayNumber = cJD.fixed_jd(dblFixed)
            Case JDE: 'Julian day number according to dynamic time
                udtDateIn.dblDayNumber = cJDE.fixed_jde(dblFixed)
            Case mjd: 'Modified Julian day number
                udtDateIn.dblDayNumber = cMJD.fixed_mjd(dblFixed)
        End Select
        udtDate.blnEve = False
    Else
        'Find start and end of day for the time given
        Call StartEndOfDay(dblFixed, enmDateType, enmTimeType, dblStart, dblEnd, intDayShift)
        'Convert date for last 0:00 UTC
        dblZeroTime = ZeroTime(dblFixed, enmTimeType)
        Call frmDate.ToDate(Int(dblFixed - dblZeroTime) + intDayShift, enmDateType, udtDateIn, blnValid)
        intDaysToAdd = 0
        While dblFixed > dblEnd 'While the time is after the end of the day
            intDaysToAdd = intDaysToAdd - 1 'increment the day and reconvert
            Call frmDate.ToDate(Int(dblFixed + intDaysToAdd + intDayShift), enmDateType, udtDateIn, blnValid)
            Call StartEndOfDay(Int(dblFixed - intDaysToAdd), enmDateType, enmTimeType, dblStart, dblEnd, intDayShift)
        Wend
        While dblFixed < dblStart 'While the time is before the beginning of the day
            intDaysToAdd = intDaysToAdd + 1 'decrement the day and reconvert
            Call frmDate.ToDate(Int(dblFixed + intDaysToAdd + intDayShift), enmDateType, udtDateIn, blnValid)
            Call StartEndOfDay(Int(dblFixed - intDaysToAdd), enmDateType, enmTimeType, dblStart, dblEnd, intDayShift)
        Wend
'        While dblFixed > dblEnd 'Fix time for Hebrew and Islamic dates
'            intDaysToAdd = intDaysToAdd - 1 'increment the day and reconvert
            Call StartEndOfDay(Int(dblFixed - intDaysToAdd + intDayShift), enmDateType, enmTimeType, dblStart, dblEnd, intDayShift)
            udtDateIn.blnEve = dblFixed < Int(dblStart + udtLocation.dblLongitude / 360) + 1 And udtDateIn.enmDateType >= Hebrew
'        Wend
        'Evaluate the time
        Call FixedToTime(dblFixed, udtTimeIn, dblStart, enmTimeType)
    End If
End Sub
Sub StartEndOfDay(dblFix As Double, enmDateType As DateType, enmTimeType As TimeType, dblStart As Double, dblEnd As Double, Optional intDayShift As Integer)
'Find the start and end of the current day and how many days to adjust from the UTC day
    Dim cUTC As New clsUTC
    Dim cLocal As New clsLocalTime
    Dim cMeanSolar As New clsMeanSolar
    Dim cTrueSolar As New clsTrueSolar
    Dim cGMST As New clsGMST
    Dim cLST As New clsLST
    Dim cSeasonal As New clsSeasonal
    Dim cMoon As New clsMoon
    Dim udtTimeOut As Mytime
        
    Select Case enmTimeType
        Case 0: 'UTC
            Call cUTC.StartEndOfDay(dblFix, enmDateType, dblStart, dblEnd, intDayShift)
        Case 1: 'Local time
            Call cLocal.StartEndOfDay(dblFix, enmDateType, dblStart, dblEnd, intDayShift)
        Case 2: 'Mean solar
            Call cMeanSolar.StartEndOfDay(dblFix, enmDateType, dblStart, dblEnd, intDayShift)
        Case 3: 'True solar
            Call cTrueSolar.StartEndOfDay(dblFix, enmDateType, dblStart, dblEnd, intDayShift)
        Case 4: 'GMST
            Call cUTC.StartEndOfDay(dblFix, enmDateType, dblStart, dblEnd, intDayShift)
        Case 5: 'LST
            Call cUTC.StartEndOfDay(dblFix, enmDateType, dblStart, dblEnd, intDayShift)
        Case 6: 'Seasonal
            Call cTrueSolar.StartEndOfDay(dblFix, enmDateType, dblStart, dblEnd, intDayShift)
    End Select
End Sub
Sub Sun() 'Calculate parameters connected witht the Sun
    Dim cSun As New clsSun
    
    Select Case cboOption2.ListIndex
        Case 0: 'Ecliptic coordinates
            lblOutput3.Caption = cSun.EclipticCoordinates
        Case 1: 'Equatorial coordinates
            lblOutput3.Caption = cSun.EquatorialCoordinates
        Case 2: 'Horizon coordinates
            lblOutput3.Caption = cSun.HorizonCoordinates
        Case 3: 'Distance & size
            lblOutput3.Caption = cSun.DistSize
        Case 4: 'Sunrise
            lblOutput3.Caption = cSun.Sunrise
        Case 5: 'Sunrise
            lblOutput3.Caption = cSun.Sunset
        Case 6: 'Magnitude
            lblOutput3.Caption = cSun.MagText
    End Select
End Sub
Sub Moon()
    Dim cMoon As New clsMoon
    
    frmGraph.Hide
    Select Case cboOption2.ListIndex
        Case 0: 'Ecliptic coordinates
            lblOutput3.Caption = cMoon.EclipticCoordinates
        Case 1: 'Equatorial coordinates
            lblOutput3.Caption = cMoon.EquatorialCoordinates
        Case 2: 'Horizon coordinates
            lblOutput3.Caption = cMoon.HorizonCoordinates
        Case 3: 'Distance & size
            lblOutput3.Caption = cMoon.DistSize
        Case 4: 'Sunrise
            lblOutput3.Caption = cMoon.Moonrise
        Case 5: 'Sunrise
            lblOutput3.Caption = cMoon.MoonSet
        Case 6: 'Magnitude
            lblOutput3.Caption = cMoon.MagText
        Case 7: 'Sunrise
            lblOutput3.Caption = cMoon.YallopQText
        Case 8: 'Sunrise
            lblOutput3.Caption = cMoon.RambamText
        Case 9: 'Sunrise
            lblOutput3.Caption = cMoon.LagPhaseDistanceText
        Case 10: 'Sunrise
            lblOutput3.Caption = cMoon.FirstVisible(dblDate + dblTime)
        Case 11: 'Sunrise
            lblOutput3.Caption = cMoon.NextNewMoonText
    End Select
End Sub
Sub Planet()
    Dim cPlanet As New clsPlanet
    
    Select Case cboOption2.ListIndex
        Case 0: 'Ecliptic coordinates
            lblOutput3.Caption = cPlanet.EclipticCoordinates(cboOption.Text)
        Case 1: 'Equatorial coordinates
            lblOutput3.Caption = cPlanet.EquatorialCoordinates(cboOption.Text)
        Case 2: 'Horizon coordinates
            lblOutput3.Caption = cPlanet.HorizonCoordinates(cboOption.Text)
        Case 3: 'Distance and size
            lblOutput3.Caption = cPlanet.DistSize(cboOption.Text)
        Case 4: 'Planet rise
            lblOutput3.Caption = cPlanet.PlanetRise(cboOption.Text)
        Case 5: 'Planet set
            lblOutput3.Caption = cPlanet.PlanetSet(cboOption.Text)
        Case 6: 'Magnitude
            lblOutput3.Caption = cPlanet.MagText(cboOption.Text)
    End Select
End Sub
Friend Sub FixedToTime(dblFix As Double, udtTimeOut As Mytime, dblStart As Double, enmType As TimeType)
'Convert a radix date to a time
'dblFix is fixed radix date
'udtTimeOut is the time type to be computed
'dblStart is the fixed radix time of the start of the day used for deciding 2nd time

    Dim udtStart As Mytime
    Dim dblTimeDif As Double
    Dim cLocalTime As New clsLocalTime
    Dim cMeanSolar As New clsMeanSolar
    Dim cUTC As New clsUTC
    Dim cGMST As New clsGMST
    Dim cLST As New clsLST
    Dim cTrueSolar As New clsTrueSolar
    Dim cSeasonal As New clsSeasonal
    Dim dbl2nd As Double
    Dim blnValid As Boolean
    
    Select Case enmType
    Case utc
        Call cUTC.ToUTC(dblFix, udtTimeOut)
        Call cUTC.ToUTC(dblStart, udtStart)
    Case localt
        Call cLocalTime.ToLocal(dblFix, udtTimeOut)
        Call cLocalTime.ToLocal(dblStart, udtStart)
    Case meansolar
        Call cMeanSolar.ToMeanSolar(dblFix, udtTimeOut)
        Call cMeanSolar.ToMeanSolar(dblStart, udtStart)
    Case gmst
        Call cGMST.ToGMST(dblFix, udtTimeOut)
        Call cGMST.ToGMST(dblStart, udtStart)
    Case lst
        Call cLST.ToLST(dblFix, udtTimeOut)
        Call cLST.ToLST(dblStart, udtStart)
    Case truesolar
        Call cTrueSolar.ToTrueSolar(dblFix, udtTimeOut)
        Call cTrueSolar.ToTrueSolar(dblStart, udtStart)
    Case seasonal
        Call cSeasonal.ToSeasonal(dblFix, udtTimeOut)
        Call cSeasonal.ToSeasonal(dblStart, udtStart)
    Case Else 'Invalid type
        Debug.Print "Error in TimeToFixed, Invalid time type: " & udtTime.enmTimeType
    End Select
    udtStart.blnSecondTime = True
    dbl2nd = TimeToFixed(udtStart, blnValid) + Int(dblStart)
    udtTimeOut.blnSecondTime = (blnValid And dblFix > dbl2nd)
End Sub
Friend Function TimeToFixed(udtTimeIn As Mytime, blnValid As Boolean) As Double
    Dim cLocalTime As New clsLocalTime
    Dim cMeanSolar As New clsMeanSolar
    Dim cUTC As New clsUTC
    Dim cGMST As New clsGMST
    Dim cLST As New clsLST
    Dim cTrueSolar As New clsTrueSolar
    Dim cSeasonal As New clsSeasonal
    
    Select Case udtTimeIn.enmTimeType
    Case utc
        TimeToFixed = cUTC.FromUTC(udtTimeIn, blnValid)
    Case localt
        TimeToFixed = cLocalTime.FromLocal(udtTimeIn, blnValid)
    Case meansolar
        TimeToFixed = cMeanSolar.FromMeanSolar(udtTimeIn, blnValid)
    Case truesolar
        TimeToFixed = cTrueSolar.FromTrueSolar(udtTimeIn, blnValid)
    Case gmst
        TimeToFixed = cGMST.FromGMST(udtTimeIn, blnValid)
    Case lst
        TimeToFixed = cLST.FromLST(udtTimeIn, blnValid)
    Case seasonal
        TimeToFixed = cSeasonal.FromSeasonal(udtTimeIn, blnValid)
    Case Else
        MsgBox ("Invalid time type in TimeToFixed")
    End Select
    TimeToFixed = TimeToFixed + Int(dblDate)
End Function

Private Sub cboOption_Click()
    Dim blnSave As Boolean
    
    blnSave = blnAllowChange
    blnAllowChange = False 'Disable evaluateion
    If optConvert Then
        lblOption2.Caption = "Time type"
        cboOption2.Clear
        cboOption2.AddItem ("UTC")
        cboOption2.AddItem ("Local")
        cboOption2.AddItem ("Mean Solar")
        cboOption2.AddItem ("True Solar")
        cboOption2.AddItem ("GMST")
        cboOption2.AddItem ("LST")
        cboOption2.AddItem ("Seasonal")
        cboOption2.ListIndex = enmLastTimeType
        cboOption2.Text = cboOption2.List(enmLastTimeType)
        If cboOption.ListIndex < 4 Then 'Don't display time time for radix dates
            lblOption2.Visible = False
            cboOption2.Visible = False
        Else 'Display for calendar dates
            lblOption2.Visible = True
            cboOption2.Visible = True
        End If
        enmLastDateType = cboOption.ListIndex
    Else
        lblOption2.Visible = True
        cboOption2.Visible = True
        intLastPar = cboOption2.ListIndex
        lblOption2.Caption = "Parameter"
        cboOption2.Clear
        cboOption2.AddItem "Ecliptic coordinates"
        cboOption2.AddItem "Equatorial coordinates"
        cboOption2.AddItem "Horizon coordinates"
        cboOption2.AddItem "Distance & size"
        cboOption2.AddItem "Rise"
        cboOption2.AddItem "Set"
        cboOption2.AddItem "Magnitude"
        If cboOption.ListIndex = 1 Then 'Moon
            cboOption2.AddItem "Yallop q"
            cboOption2.AddItem "Rambam"
            cboOption2.AddItem "Phase/Lag/Distance"
            cboOption2.AddItem "First/last visible"
            cboOption2.AddItem "Next new Moon"
        End If
        If cboOption.ListIndex <> 1 And intLastPar > 6 Then intLastPar = 6
        cboOption2.ListIndex = intLastPar
        cboOption2.Text = cboOption2.List(intLastPar)
        blnAllowChange = blnSave 'Enable and evaluate
    End If
    blnAllowChange = blnSave
    If blnAllowChange Then
        Call Evaluate
    End If
End Sub

Private Sub cboOption2_Click()
    If blnAllowChange Then
        If optConvert Then
            enmLastTimeType = cboOption2.ListIndex
            Call Evaluate
        Else
            Select Case cboOption.ListIndex
                Case 0: 'Sun
                    Call Sun
                Case 1:
                    Call Moon
                Case Else:
                    Call Planet
            End Select
            intLastPar = cboOption2.ListIndex
        End If
    End If
End Sub

Private Sub cmdChangeDate_Click()
    lblOutput3.Enabled = False
    frmDate.Show (vbModal)
    lblOutput3.Enabled = True
    Call Evaluate
End Sub

Private Sub cmdChangeLocation_Click()
    lblOutput3.Enabled = False
    frmLocation.Show (vbModal)
    lblOutput3.Enabled = True
    Call Evaluate
End Sub

Private Sub cmdChangeTime_Click()
    lblOutput3.Enabled = False
    frmTime.Show (vbModal)
    lblOutput3.Enabled = True
    Call Evaluate
End Sub

Private Sub cmdChangeWeather_Click()
    lblOutput3.Enabled = False
    frmWeather.Show (vbModal)
    lblOutput3.Enabled = True
    Call Evaluate
End Sub

Private Sub cmdCRight_Click()
    MsgBox ("(C)Roy E. Hoffman 2000" & vbCrLf & "Permission is given to use this software for non-commercial" & vbCrLf & "religious and scientific purposes. If you wish to use this" & vbCrLf & "software for commercial purposes, please contact me to discuss" & vbCrLf & "terms. If you have any comments" & vbCrLf & "or suggestions, please contact me (roy@shum.cc.huji.ac.il)." & vbCrLf & "While I will do my best to acknowledge any suggestions in" & vbCrLf & "the code, I will assume that I have your permission to use" & vbCrLf & "any information you give me as I wish.")
End Sub

Private Sub cmdHelp_Click()
    CommonDialog1.HelpFile = "LunaCal.hlp"
    CommonDialog1.HelpCommand = cdlHelpForceFile
    CommonDialog1.ShowHelp
End Sub

Private Sub cmdPrint_Click()
    Dim X As Printer
    Dim curDisplay As Object
    
    Set curDisplay = Printer
    curDisplay.Print "Input values"
    curDisplay.Print "    " & lblTime
    curDisplay.Print "    " & lblDate
    curDisplay.Print "    " & lblLocation
    curDisplay.Print "    " & lblWeather
    curDisplay.Print
    curDisplay.Print "Output results"
    If optConvert Then
        curDisplay.Print "    " & "Convert date"
        curDisplay.Print "    " & "Date type " & cboOption.Text
        curDisplay.Print "    " & "Time type " & cboOption2.Text
    Else
        curDisplay.Print "    " & "Moon, Sun, Planets"
        curDisplay.Print "    " & "Heavenly body " & cboOption.Text
        curDisplay.Print "    " & "Paramter " & cboOption2.Text
    End If
    curDisplay.Print lblOutput3
    If frmGraph.Visible Then
        curDisplay.Print "Moon: Red - not visible, Blue - May be visible, Black - Definately visible"
        Call frmGraph.DrawGraph(curDisplay, False, curDisplay.CurrentY + 2 * curDisplay.TextHeight("0"))
    End If
    Printer.EndDoc
End Sub

Private Sub Form_Load()
    Dim intI As Integer
    Dim blnFoundData As Boolean
    Dim blnValid As Boolean
    Dim cGregorian As New clsGregorian
    Dim cLocalT As New clsLocalTime
    'Data files not read for DetlaT and Moon
    strDecimalSymbol = Mid(Format(0#, "0.0"), 2, 1)
    blnDeltaTRead = False
    blnMoonRead = False
    'Read data for locations
    Call GetLocationData(blnFoundData)
    'Read last saved location
    Open "Curloc.txt" For Input Access Read As 1
    With udtLocation
        Input #1, .blnAhead
        Input #1, .blnDMSMode
        Input #1, .blnDST
        Input #1, .blnDSTAuto
        Input #1, .blnNameValid
        Input #1, .dblHeight
        Input #1, .dblLatitude
        Input #1, .dblLongitude
        Input #1, .dblTZ
        Input #1, .intNTZ
        Input #1, .intTZH
        Input #1, .intTZM
        Input #1, .strCountryState
        Input #1, .strNeighborhood
        Input #1, .strTownCity
        Input #1, .udtLatitude.blnSign
        Input #1, .udtLatitude.dblSeconds
        Input #1, .udtLatitude.intDegreesHours
        Input #1, .udtLatitude.intMinutes
        Input #1, .udtLongitude.blnSign
        Input #1, .udtLongitude.dblSeconds
        Input #1, .udtLongitude.intDegreesHours
        Input #1, .udtLongitude.intMinutes
        ReDim .udtTZ(.intNTZ - 1)
        For intI = 0 To .intNTZ - 1
            With .udtTZ(intI)
                Input #1, .blnDST
                Input #1, .blnLast
                Input #1, .dblLast
                Input #1, .dblTZ
                Input #1, .udtDSTEnd.intDate
                Input #1, .udtDSTEnd.intDayOfWeek
                Input #1, .udtDSTEnd.intHour
                Input #1, .udtDSTEnd.intMonthNo
                Input #1, .udtDSTEnd.intWeekNo
                Input #1, .udtDSTStart.intDate
                Input #1, .udtDSTStart.intDayOfWeek
                Input #1, .udtDSTStart.intHour
                Input #1, .udtDSTStart.intMonthNo
                Input #1, .udtDSTStart.intWeekNo
            End With
        Next
    End With
    Close 1
    'Date and time set to current time - suggested by Lionel Isaacs
    udtDate.dblDayNumber = Date + Time + 693594
    udtDate.blnCE = True
    udtDate.blnEve = False
    udtTime.bln24Hr = True
    udtTime.blnSecondTime = False
    Call ToDateTime(udtDate.dblDayNumber, udtDate, Gregorian, udtTime, utc, blnValid)
    udtDate.dblDayNumber = udtDate.dblDayNumber - cLocalT.GetTZ(udtDate.dblDayNumber, blnValid) / 24
    Call ToDateTime(udtDate.dblDayNumber, udtDate, Gregorian, udtTime, localt, blnValid)
    'Weather
    udtWeather.udtBasis = LocalW
    With udtWeather.udtClimate
        .udtHumidity.dblAnnualRange = 20
        .udtHumidity.dblDailyRange = 20
        .udtHumidity.dblMean = 60
        .udtPressure.dblAnnualRange = 7
        .udtPressure.dblDailyRange = 0
        .udtPressure.dblMean = 922
        .udtTemperature.dblAnnualRange = 18
        .udtTemperature.dblDailyRange = 7
        .udtTemperature.dblMean = 16
    End With
    'Set default output options
    intLastPar = 0
    intLastPlanet = 0
    enmLastDateType = Gregorian 'No valid last type
    enmLastTimeType = localt
    'Set ouput options
    blnAllowChange = False 'Disable evaluation
    cmdT.Visible = False
    enmLastDateType = Gregorian
    lblOption.Caption = "Date type"
    cboOption.Clear
    cboOption.AddItem ("Fixed")
    cboOption.AddItem ("JD")
    cboOption.AddItem ("JDE")
    cboOption.AddItem ("MJD")
    cboOption.AddItem ("Gregorian")
    cboOption.AddItem ("Julian")
    cboOption.AddItem ("Hebrew")
    cboOption.AddItem ("Islamic")
    cboOption.ListIndex = enmLastDateType
    cboOption.Text = cboOption.List(enmLastDateType)
    enmLastTimeType = localt
    lblOption2.Caption = "Time type"
    cboOption2.Clear
    cboOption2.AddItem ("UTC")
    cboOption2.AddItem ("Local")
    cboOption2.AddItem ("Mean Solar")
    cboOption2.AddItem ("True Solar")
    cboOption2.AddItem ("GMST")
    cboOption2.AddItem ("LST")
    cboOption2.AddItem ("Seasonal")
    cboOption2.ListIndex = enmLastTimeType
    cboOption2.Text = cboOption2.List(enmLastTimeType)
    blnAllowChange = True 'Enable and evaluate
    Call Evaluate
End Sub
Sub GetLocationData(blnFoundData As Boolean) 'Read data from file
'The data consists of fields separated by commas
'A field starting with a # is a comment
'The data has the following structure
'Number of countries (states in USA, Canada and Australia)
'For each country
'   Name
'   Number of epochs for automatic time zone paramters
'   For each epoch
'       End of epoch in fixed radix or FALSE for no end
'       Standard time in hours ahead of UTC
'       DST exists as boolean
'       If DST then
'           For start and end
'               Hour of day when change occurs
'               Day of week (Sunday = 0 to Saturday = 6)
'               Week number (0 means on the date specified rather than a day of the week, 5 means last week of month)
'               Date of month from which weeks are counted
'               Month number (January = 1 to December = 12)
'           next
'       endif
'   next
'   Number of cities (towns or other places)
'   For each city
'       Name
'       Number of neighborhoods
'       For each neighborhood
'           Name (defualt = "Center")
'           Latitude (degrees, North positive)
'           Longitude (degrees, East positive)
'           Height above sea-level (m)
'           Mean Temperature
'           Daily temperature range
'           Anuual temperature range
'           Mean Pressure
'           Daily pressure range
'           Annual pressure range
'           Mean Humidity
'           Daily humidity range
'           Annual humidity range
'       Next
'   Next
'Next
    Dim strLine As String
    Dim intCountryState As Integer
    Dim intTZ As Integer
    Dim intCity As Integer
    Dim intNeighborhood As Integer
    
    Open "Locations.txt" For Input Access Read As 1
    'Read number of countries
    blnFoundData = True
    strLine = GetNextLine()
    If Not IsNumeric(strLine) Then
        MsgBox ("Error in location file: Number of countries must be a number.")
        blnFoundData = False
    ElseIf strLine > 32766 Or strLine < 0 Or strLine > Int(strLine) Then
        MsgBox ("Error in location file: Number of countries must be a positive integer less that 32767.")
        blnFoundData = False
    End If
    If blnFoundData Then
    With udtLocationData
        .intNStatesCountries = strLine
        ReDim .udtCountryState(.intNStatesCountries)
        For intCountryState = 0 To .intNStatesCountries - 1
            With .udtCountryState(intCountryState)
                'Read country name
                .strCountryState = GetNextLine()
                If .strCountryState = "" Then
                    MsgBox ("Error in location file: Country/State name (" & intCountryState & ") missing.")
                    blnFoundData = False
                End If
                If blnFoundData Then
                    'Read number of time zone epochs
                    strLine = GetNextLine()
                    If Not IsNumeric(strLine) Then
                        MsgBox ("Error in location file: Number of time zone histories must be a number for " & .strCountryState & ".")
                        blnFoundData = False
                    ElseIf strLine > 32766 Or strLine < 0 Or strLine > Int(strLine) Then
                        MsgBox ("Error in location file: Number of time zone histories must be a positive integer less that 32767 for " & .strCountryState & ".")
                        blnFoundData = False
                    End If
                End If
                If blnFoundData Then
                    .intNTZ = strLine
                    ReDim .udtTZ(.intNTZ)
                    For intTZ = 0 To .intNTZ - 1
                        With .udtTZ(intTZ)
                            'Get end of epoch if there is an end
                            strLine = GetNextLine()
                            If strLine = "FALSE" Then
                                .blnLast = False
                            Else
                                .blnLast = True
                                If Not IsNumeric(strLine) Then
                                    MsgBox ("Error in location file: Last applicable date for time zone must be a number for " & udtLocationData.udtCountryState(intCountryState).strCountryState & " epoch " & intTZ & ".")
                                    blnFoundData = False
                                Else
                                    .dblLast = strLine
                                End If
                            End If
                            If blnFoundData Then
                                'Get standard time
                                strLine = GetNextLine()
                                If Not IsNumeric(strLine) Then
                                    MsgBox ("Error in location file: Time Zone must be a number for " & udtLocationData.udtCountryState(intCountryState).strCountryState & " epoch " & intTZ & ".")
                                    blnFoundData = False
                                ElseIf strLine < -14 Or strLine > 14 Then
                                    MsgBox ("Error in location file: Time Zone must be between -14 and 14 for " & udtLocationData.udtCountryState(intCountryState).strCountryState & " epoch " & intTZ & ".")
                                    blnFoundData = False
                                Else
                                    .dblTZ = strLine
                                End If
                                If blnFoundData Then
                                    'See if there is DST
                                    strLine = GetNextLine()
                                    If strLine = "FALSE" Then
                                        .blnDST = False
                                    ElseIf strLine = "TRUE" Then
                                        .blnDST = True
                                    Else
                                        MsgBox ("Error in location file: DST must be boolean  for " & udtLocationData.udtCountryState(intCountryState).strCountryState & " epoch " & intTZ & ".")
                                        blnFoundData = False
                                    End If
                                    If .blnDST And blnFoundData Then
                                        'Read time change parameters
                                        Call GetNTZ(.udtDSTStart)
                                        Call GetNTZ(.udtDSTEnd)
                                    End If
                                End If
                            End If
                        End With
                    Next
                End If
                If blnFoundData Then
                    'Read number of cities
                    strLine = GetNextLine()
                    If Not IsNumeric(strLine) Then
                        MsgBox ("Error in location file: Number of cities must be a number for " & .strCountryState & ".")
                        blnFoundData = False
                    ElseIf strLine < 0 Or strLine > 32766 Or Int(strLine) > strLine Then
                        MsgBox ("Error in location file: Number of cities must be a positive integer for " & .strCountryState & ".")
                        blnFoundData = False
                    Else
                        .intNCities = strLine
                    End If
                    If blnFoundData Then
                        ReDim .udtCity(.intNCities)
                        For intCity = 0 To .intNCities - 1
                            With .udtCity(intCity)
                                'Read city name
                                .strCity = GetNextLine()
                                If .strCity = "" Then
                                    MsgBox ("Error in location file: Country/State name missing for " & udtLocationData.udtCountryState(intCountryState).strCountryState & " city (" & intCity & ").")
                                    blnFoundData = False
                                End If
                                If blnFoundData Then
                                    'Read number of neighborhoods
                                    strLine = GetNextLine()
                                    If Not IsNumeric(strLine) Then
                                        MsgBox ("Error in location file: Number of neighborhoods must be a number for " & udtLocationData.udtCountryState(intCountryState).strCountryState & " city (" & intCity & ").")
                                        blnFoundData = False
                                    ElseIf strLine < 0 Or strLine > 32766 Or Int(strLine) > strLine Then
                                        MsgBox ("Error in location file: Number of neighborhoods must be a positive integer for " & udtLocationData.udtCountryState(intCountryState).strCountryState & " city (" & intCity & ").")
                                        blnFoundData = False
                                    End If
                                    If blnFoundData Then
                                        .intNNeighborhoods = strLine
                                        ReDim .udtNeighborhood(.intNNeighborhoods)
                                        For intNeighborhood = 0 To .intNNeighborhoods - 1
                                            With .udtNeighborhood(intNeighborhood)
                                                'Read neighborhood name
                                                .strNeighborhood = GetNextLine()
                                                If .strNeighborhood = "" Then
                                                    MsgBox ("Error in location file: Country/State name missing for " & udtLocationData.udtCountryState(intCountryState).strCountryState & ", " & udtLocationData.udtCountryState(intCountryState).udtCity(intCity).strCity & " neighborhood (" & intNeighborhood & ".")
                                                    blnFoundData = False
                                                End If
                                                If blnFoundData Then
                                                    'Read Latitude
                                                    strLine = GetNextLine()
                                                    If Not IsNumeric(strLine) Then
                                                        MsgBox ("Error in location file: Latitude must be a number for " & udtLocationData.udtCountryState(intCountryState).strCountryState & ", " & udtLocationData.udtCountryState(intCountryState).udtCity(intCity).strCity & ", " & .strNeighborhood & ".")
                                                        blnFoundData = False
                                                    ElseIf strLine < -90 Or strLine > 90 Then
                                                        MsgBox ("Error in location file: Latitude must be between -90 and 90 for " & udtLocationData.udtCountryState(intCountryState).strCountryState & ", " & udtLocationData.udtCountryState(intCountryState).udtCity(intCity).strCity & ", " & .strNeighborhood & ".")
                                                        blnFoundData = False
                                                    Else
                                                        .udtPosition.dblLatitude = strLine
                                                    End If
                                                End If
                                                If blnFoundData Then
                                                    'Read Longitude
                                                    strLine = GetNextLine()
                                                    If Not IsNumeric(strLine) Then
                                                        MsgBox ("Error in location file: Longitude must be a number for " & udtLocationData.udtCountryState(intCountryState).strCountryState & ", " & udtLocationData.udtCountryState(intCountryState).udtCity(intCity).strCity & ", " & .strNeighborhood & ".")
                                                        Return
                                                    ElseIf strLine <= -180 Or strLine > 180 Then
                                                        MsgBox ("Error in location file: Longitude must be between -180 and 180 for " & udtLocationData.udtCountryState(intCountryState).strCountryState & ", " & udtLocationData.udtCountryState(intCountryState).udtCity(intCity).strCity & ", " & .strNeighborhood & ".")
                                                        Return
                                                    Else
                                                        .udtPosition.dblLongitude = strLine
                                                    End If
                                                End If
                                                If blnFoundData Then
                                                    'Read height above sea-level
                                                    strLine = GetNextLine()
                                                    If Not IsNumeric(strLine) Then
                                                        MsgBox ("Error in location file: Height must be a number for " & udtLocationData.udtCountryState(intCountryState).strCountryState & ", " & udtLocationData.udtCountryState(intCountryState).udtCity(intCity).strCity & ", " & .strNeighborhood & ".")
                                                        blnFoundData = False
                                                    ElseIf strLine < HeightMin Or strLine > HeightMax Then
                                                        MsgBox ("Error in location file: Height must be between " & HeightMin & " and " & HeightMax & " for " & udtLocationData.udtCountryState(intCountryState).strCountryState & ", " & udtLocationData.udtCountryState(intCountryState).udtCity(intCity).strCity & ", " & .strNeighborhood & ".")
                                                        blnFoundData = False
                                                    Else
                                                        .udtPosition.dblHeight = strLine
                                                    End If
                                                End If
                                                If blnFoundData Then
                                                'Read parameters for local climate
                                                With .udtLocalClimate
                                                    With .udtTemperature
                                                        'Read Temperature parameters
                                                        'Mean
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Mean Temperature must be a number.")
                                                            Return
                                                        ElseIf strLine < TMin Or strLine > TMax Then
                                                            MsgBox ("Error in location file: Mean Temperature must be between " & TMin & " and " & TMax & ".")
                                                            Return
                                                        End If
                                                        .dblMean = strLine
                                                        'Daily range
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Daily Temperature range must be a number.")
                                                            Return
                                                        End If
                                                        .dblDailyRange = strLine
                                                        'Annual range
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Annual Temperature range must be a number.")
                                                            Return
                                                        End If
                                                        .dblAnnualRange = strLine
                                                    End With
                                                    With .udtPressure
                                                        'Read pressure parameters
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Mean Pressure must be a number.")
                                                            Return
                                                        ElseIf strLine < PMin Or strLine > PMax Then
                                                            MsgBox ("Error in location file: Mean Pressure must be between " & PMin & " and " & PMax & ".")
                                                            Return
                                                        End If
                                                        .dblMean = strLine
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Daily Pressure range must be a number.")
                                                            Return
                                                        End If
                                                        .dblDailyRange = strLine
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Annual Temperature range must be a number.")
                                                            Return
                                                        End If
                                                        .dblAnnualRange = strLine
                                                    End With
                                                    With .udtHumidity
                                                        'Read humidity parameters
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Mean Temperature must be a number.")
                                                            Return
                                                        ElseIf strLine < HMin Or strLine > HMax Then
                                                            MsgBox ("Error in location file: Mean Humidity must be between " & HMin & " and " & HMax & ".")
                                                            Return
                                                        End If
                                                        .dblMean = strLine
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Daily Humidity range must be a number.")
                                                            Return
                                                        End If
                                                        .dblDailyRange = strLine
                                                        strLine = GetNextLine()
                                                        If Not IsNumeric(strLine) Then
                                                            MsgBox ("Error in location file: Annual Humidity range must be a number.")
                                                            Return
                                                        End If
                                                        .dblAnnualRange = strLine
                                                    End With
                                                End With
                                            End If
                                            End With
                                        Next
                                    End If
                                End If
                            End With
                        Next
                    End If
                End If
            End With
        Next
    End With
    End If
    Close 1
End Sub
Friend Sub GetNTZ(udtTZDST As ClockChange)
'Read parameters for time change
    Dim strLine As String
    
    With udtTZDST
        'Hour of change
        strLine = GetNextLine()
        If Not IsNumeric(strLine) Then
            MsgBox ("Error in location file: DST changeover hour must be a number.")
            Return
        ElseIf strLine < 0 Or strLine > 23 Or Int(strLine) > strLine Then
            MsgBox ("Error in location file: DST changeover hour must be an integer from 0 to 23.")
            Return
        End If
        .intHour = strLine
        'Day of week
        strLine = GetNextLine()
        If Not IsNumeric(strLine) Then
            MsgBox ("Error in location file: DST changeover day must be a number.")
            Return
        ElseIf strLine < 0 Or strLine > 6 Or Int(strLine) > strLine Then
            MsgBox ("Error in location file: DST changeover day must be an integer from 0 to 6.")
            Return
        End If
        .intDayOfWeek = strLine
        'Week (0 = on the date specified, 5 = last week)
        strLine = GetNextLine()
        If Not IsNumeric(strLine) Then
            MsgBox ("Error in location file: DST changeover week must be a number.")
            Return
        ElseIf strLine < 0 Or strLine > 6 Or Int(strLine) > strLine Then
            MsgBox ("Error in location file: DST changeover week must be an integer from 0 to 5.")
            Return
        End If
        .intWeekNo = strLine
        'Date of month from which weeks are counted
        strLine = GetNextLine()
        If Not IsNumeric(strLine) Then
            MsgBox ("Error in location file: DST changeover month must be a number.")
            Return
        ElseIf strLine < 0 Or strLine > 31 Or Int(strLine) > strLine Then
            MsgBox ("Error in location file: DST changeover date must be an integer from 1 to 12.")
            Return
        End If
        .intDate = strLine
        'Month
        strLine = GetNextLine()
        If Not IsNumeric(strLine) Then
            MsgBox ("Error in location file: DST changeover date must be a number.")
            Return
        ElseIf strLine < 0 Or strLine > 12 Or Int(strLine) > strLine Then
            MsgBox ("Error in location file: DST changeover month must be an integer from 1 to 12.")
            Return
        End If
        .intMonthNo = strLine
    End With
End Sub
Function GetNextLine() As String
'Get next field that is not a comment (starting with #)
    Dim blnFoundData As Boolean
    Dim strLine As String
    Dim intI As Integer

    blnFoundData = False
    While Not EOF(1) And Not blnFoundData
        Input #1, strLine
        If strLine <> "" And Mid(strLine, 1, 1) <> "#" Then
            blnFoundData = True
        End If
    Wend
    strLine = ToIntNum(strLine)
    If Not blnFoundData Then strLine = ""
    GetNextLine = strLine
End Function
Private Sub Form_Unload(Cancel As Integer)
    Dim intI As Integer
    
    'Save current location for next time
    Open "Curloc.txt" For Output Access Write As 1
    With udtLocation
        Write #1, .blnAhead
        Write #1, .blnDMSMode
        Write #1, .blnDST
        Write #1, .blnDSTAuto
        Write #1, .blnNameValid
        Write #1, .dblHeight
        Write #1, .dblLatitude
        Write #1, .dblLongitude
        Write #1, .dblTZ
        Write #1, .intNTZ
        Write #1, .intTZH
        Write #1, .intTZM
        Write #1, .strCountryState
        Write #1, .strNeighborhood
        Write #1, .strTownCity
        Write #1, .udtLatitude.blnSign
        Write #1, .udtLatitude.dblSeconds
        Write #1, .udtLatitude.intDegreesHours
        Write #1, .udtLatitude.intMinutes
        Write #1, .udtLongitude.blnSign
        Write #1, .udtLongitude.dblSeconds
        Write #1, .udtLongitude.intDegreesHours
        Write #1, .udtLongitude.intMinutes
        For intI = 0 To .intNTZ - 1
            With .udtTZ(intI)
                Write #1, .blnDST
                Write #1, .blnLast
                Write #1, .dblLast
                Write #1, .dblTZ
                Write #1, .udtDSTEnd.intDate
                Write #1, .udtDSTEnd.intDayOfWeek
                Write #1, .udtDSTEnd.intHour
                Write #1, .udtDSTEnd.intMonthNo
                Write #1, .udtDSTEnd.intWeekNo
                Write #1, .udtDSTStart.intDate
                Write #1, .udtDSTStart.intDayOfWeek
                Write #1, .udtDSTStart.intHour
                Write #1, .udtDSTStart.intMonthNo
                Write #1, .udtDSTStart.intWeekNo
            End With
        Next
    End With
    Close 1
    'Unload all forms
    Unload frmDate
    Unload frmLocation
    Unload frmTime
    Unload frmWeather
    Unload frmGraph
    Unload Me
End Sub


Private Sub optBody_Click()
    If blnAllowChange Then
        blnAllowChange = False 'Disable evaluation
        lblOption.Caption = "Body"
        cboOption.Clear
        cboOption.AddItem ("Sun")
        cboOption.AddItem ("Moon")
        cboOption.AddItem ("Mercury")
        cboOption.AddItem ("Venus")
        cboOption.AddItem ("Jupiter")
        cboOption.ListIndex = intLastPlanet
        cboOption.Text = cboOption.List(intLastPlanet)
        blnAllowChange = True 'Enable and evaluate
        Call Evaluate
    End If
End Sub

Private Sub optConvert_Click()
    If blnAllowChange Then
        blnAllowChange = False 'Disable evaluation
        lblOption.Caption = "Date type"
        cboOption.Clear
        cboOption.AddItem ("Fixed")
        cboOption.AddItem ("JD")
        cboOption.AddItem ("JDE")
        cboOption.AddItem ("MJD")
        cboOption.AddItem ("Gregorian")
        cboOption.AddItem ("Julian")
        cboOption.AddItem ("Hebrew")
        cboOption.AddItem ("Islamic")
        cboOption.ListIndex = enmLastDateType
        cboOption.Text = cboOption.List(enmLastDateType)
        blnAllowChange = True 'Enable and evaluate
        Call Evaluate
    End If
End Sub
